function [ output_args ] = uiOptions(hObject, hMainFig, eventdata, handles)
% this function creates a Options panel
% Written by Partic Zimmermann, Utrecht University, April 2016.


    % --------------------------------------------
    debugMsg( 'opening uiOptions()', 2 )
    % --------------------------------------------
    %search and delete old existing Options figure
    hOld = findobj('Tag','uiFig_Options');
    delete(hOld);
    % -----------------------------------------------------------------------------
    % -----------------------------------------------------------------------------
    % find position fo mainfigure and place deleteFig above
    hMainFigPOS = get(findobj('Tag','mainFigure'),'Position'); 
    % -----------------------------------------------------------------------------            
    hFig_Options = figure;
    figPos = get(hFig_Options,'Position');
    set(hFig_Options,...
        'Position',[hMainFigPOS(1)+200 hMainFigPOS(2)+200 320 160],...    %         'Position',[figPos(1:2) 320 160],...
        'Toolbar','none',...
        'Units','Pixel',...
        'Tag','uiFig_Options',...
        'Menubar','none',...
        'windowstyle','modal',...       % MODAL: STAY ON TOP        
        'CloseRequestFcn',{@closeOptions, hMainFig, handles},...
        'Name',['Select options for the calculation...'],...
        'NumberTitle','off');
    % -----------------------------------------------------------------------------

    xx0 = 20;
    yy0 = 130;


    hPan = uipanel(hFig_Options,...
        'Title','Options',...
        'FontSize',12,...
        'Units','Pixel',...
        'Position',[10 10 300 140]);
    
%     cbExpectVals = uicontrol(hPan,...
%             'Style', 'checkbox',...
%             'Position',[xx0 yy0 200 15],...
%             'String',['   Calculate Expectation Values'],...                      %['Z=' num2str(z)],...    {eleStr; ['Z=' num2str(z)]}    'HorizontalAlignment','center',...  ['<html><center>' eleStr '<br><font size=2>Z=' num2str(z) '</font><center></html>']
%             'FontSize',12,...
%             'Value',handles.appSettings.calcEigenVals,...
%             'Tag',['cb_calcExpectVals']);    %,...
% %             'Callback',{@selectElement_Callback, handles});
    
    editNoOfEV = uicontrol(hPan,...
            'Style', 'edit',...
            'Position',[xx0-5 yy0-30 30 20],...
            'String',num2str(handles.appSettings.noOfEV),...             
            'FontSize',12,...
            'Value',1,...
            'Callback',{@checkOptions, hMainFig, handles},...
            'Tag',['edit_noOfEV']); 
    txtNoOfEV = uicontrol(hPan,...
            'Style', 'text',...
            'Position',[xx0+30 yy0-30 230 20],...
            'String',['Observables: Number of States (Npsi)'],...             
            'FontSize',12,...
            'HorizontalAlignment','left',...
            'Tag',['txt_noOfEV']); 
  
        
    editNoOfGS = uicontrol(hPan,...
            'Style', 'edit',...
            'Position',[xx0-5 yy0-60 30 20],...
            'String',num2str(handles.appSettings.noOfGS),...                    
            'FontSize',12,...
            'Value',1,...
            'Callback',{@checkOptions, hMainFig, handles},...
            'Tag',['edit_noOfGS']); 
     txtGS_NoOfGS = uicontrol(hPan,...
            'Style', 'text',...
            'Position',[xx0+30 yy0-60 230 20],...
            'String',['Plotting: Number of States (pltPsiMax)'],...             
            'FontSize',12,...
            'HorizontalAlignment','left',...
            'Tag',['txt_NoOfGS']);  
 
        
    % --- Magnetic field direction Bx    
    editBx = uicontrol(hPan,...
            'Style', 'edit',...
            'Position',[xx0-5 yy0-90 30 20],...
            'String',num2str(handles.appSettings.Bx),... %            'String',num2str(handles.appSettings.noOfGS),...                    
            'FontSize',12,...
            'Value',1,...
            'Callback',{@checkOptions, hMainFig, handles},...
            'Tag',['edit_magnBx']); 
     txtBx = uicontrol(hPan,...
            'Style', 'text',...
            'Position',[xx0+28 yy0-90 30 20],...
            'String',['x'],...             
            'FontSize',12,...
            'HorizontalAlignment','left',...
            'Tag',['txt_magnBx']);          
        
    % --- Magnetic field direction By    
    editBy = uicontrol(hPan,...
            'Style', 'edit',...
            'Position',[xx0-5+55 yy0-90 30 20],...
            'String',num2str(handles.appSettings.By),... %            'String',num2str(handles.appSettings.noOfGS),...                    
            'FontSize',12,...
            'Value',1,...
            'Callback',{@checkOptions, hMainFig, handles},...
            'Tag',['edit_magnBy']); 
     txtBy = uicontrol(hPan,...
            'Style', 'text',...
            'Position',[xx0+28+55 yy0-90 230 20],...
            'String',['y'],...             
            'FontSize',12,...
            'HorizontalAlignment','left',...
            'Tag',['txt_magnBy']);          
        
    % --- Magnetic field direction Bz    
    editBz = uicontrol(hPan,...
            'Style', 'edit',...
            'Position',[xx0-5+110 yy0-90 30 20],...
            'String',num2str(handles.appSettings.Bz),... %            'String',num2str(handles.appSettings.noOfGS),...                    
            'FontSize',12,...
            'Value',1,...
            'Callback',{@checkOptions, hMainFig, handles},...
            'Tag',['edit_magnBz']); 
     txtBz = uicontrol(hPan,...
            'Style', 'text',...
            'Position',[xx0+28+110 yy0-90 230 20],...
            'String',['z'],...             
            'FontSize',12,...
            'HorizontalAlignment','left',...
            'Tag',['txt_magnBz']);          
        
     txtBz = uicontrol(hPan,...
            'Style', 'text',...
            'Position',[xx0+170 yy0-90 230 20],...
            'String',[' with B || k || [xyz]'],...             
            'FontSize',12,...
            'HorizontalAlignment','left',...
            'Tag',['txt_magnBz']);
        
%     handles
    % --------------------------------------------
    % Update handles structure
    guidata(hMainFig, handles);              % NEEDED to READ/UPDATE new handles structure !!  (e.g. lastDir)
    % --------------------------------------------

    % -----------------------------------------------------------------------------
    % -----------------------------------------------------------------------------
    function checkOptions(hObject, eventdata, hMainFig, handles)
        % TODO: updating not 100% live data (used data as opened.)
        % --------------------------------------------
        
        thisTag = hObject.Tag
        
        tmpEV = str2num(getStrTag('edit_noOfEV'));
        tmpGS = str2num(getStrTag('edit_noOfGS'));
        
        tmpBx = str2num(getStrTag('edit_magnBx'));
        tmpBy = str2num(getStrTag('edit_magnBy'));
        tmpBz = str2num(getStrTag('edit_magnBz'));
        
        if (hObject.Tag == ['edit_noOfEV'] )
            if ~(tmpEV > 0) || (tmpEV <  tmpGS)         
    %              setStrTag({'edit_noOfEV'},num2str(handles.options.noOfEV))
                hObject.String = num2str(handles.appSettings.noOfEV);
            else
                handles.appSettings.noOfEV = tmpEV;
            end    
        end    
        % --------------------------------------------
        if (hObject.Tag == ['edit_noOfGS'] )
            if (~(tmpGS > 0) || (tmpGS > tmpEV) )     
%             setStrTag({'edit_noOfGS'},num2str(handles.options.noOfGS))
               hObject.String = num2str(handles.appSettings.noOfGS);
            else
               handles.appSettings.noOfGS = tmpGS;
            end    
        end   
        % --------------------------------------------
        % read checkbox and store in handles.options
        if getValTag('cb_calcCFdiagram') == 1
            handles.appSettings.calcELDiagram = 1;                  % NEW Store in appSettings  (is also saved to file)
        elseif getValTag('cb_calcCFdiagram') == 0
            handles.appSettings.calcELDiagram = 0;                  % NEW Store in appSettings  (is also saved to file)        
        else
            setValTag('cb_calcCFdiagram',handles.appSettings.calcELDiagram)
        end          
        % --------------------------------------------
%         if (hObject.Tag == ['edit_magnBx'] )
% %             if (~(tmpBvec > 0) || (tmpGS > tmpEV) )     
% % %             setStrTag({'edit_noOfGS'},num2str(handles.options.noOfGS))
% %                hObject.String = num2str(handles.appSettings.noOfGS);
% %             else
%                handles.appSettings.Bx = tmpBx;
% %             end    
%         end   

% handles.appSettings = rmfield(handles.appSettings,'Bx')
% handles.appSettings = rmfield(handles.appSettings,'Bx')
% handles.appSettings = rmfield(handles.appSettings,'By')



        % --------------------------------------------
        if (hObject.Tag == ['edit_magnBx'] )
            if isreal(tmpBx)
                handles.appSettings.Bx = tmpBx;
            end    
        end
        % --------------------------------------------
        if (hObject.Tag == ['edit_magnBy'] )
            if isreal(tmpBy)
                handles.appSettings.By = tmpBy;
            end    
        end   
        % --------------------------------------------
        if (hObject.Tag == ['edit_magnBz'] )
            if isreal(tmpBx)               
                handles.appSettings.Bz = tmpBz;
            end
        end           
        % --------------------------------------------
        % Update handles structure
        guidata(hMainFig, handles);              % NEEDED to READ/UPDATE new handles structure !!  (e.g. lastDir)
        % --------------------------------------------
        handles = writeOptions2Handles( handles );
%         hMainFig
        % --------------------------------------------
        % Update handles structure
        guidata(hMainFig, handles);              % NEEDED to READ/UPDATE new handles structure !!  (e.g. lastDir)
        % --------------------------------------------
                
    end    
    % -----------------------------------------------------------------------------
    function closeOptions(hObject, eventdata, hMainFig, handles)
    

        % --------------------------------------------        
        handles = writeOptions2Handles( handles );
        % --------------------------------------------        
        setValTag({'cb_Options'},0)
        % --------------------------------------------
        delete(hObject);
        % --------------------------------------------
        % Update handles structure
        guidata(hMainFig, handles);              % NEEDED to READ/UPDATE new handles structure !!  (e.g. lastDir)
        % --------------------------------------------

    end
    % -----------------------------------------------------------------------------    
    % -----------------------------------------------------------------------------
    % -----------------------------------------------------------------------------
    % -----------------------------------------------------------------------------
end

